
; :_RAM 	$0000 -> $1FFF		BE CAREFUL STACK POINTER at $0100 -> $01FF					:
	

; ::	ADDRESS														:
	Address_NameTable	EQU $60 ; 2 BYTES ; Nametable Position Address for write CHR ($2000 = Table1, $2400 = table2)
	Address_SwapBuffer	EQU $62 ; 2 BYTES ; Need for Swap Between Buffer 1/2
	

; ::	COMMAND														:
	Do_DrawBuffer		EQU $6A	; To know when Buffer need to be draw in PPU ( = 2 because there is 2 Buffers Column )
	Do_UpdatePPU		EQU $6B	; To know when PPU need to Update Modes (ex: change nametables)
	Do_UpdatePalette	EQU $6C ; To know when Color need to be swapped
	
	
; ::	VBLANK														:
	VBlank_nCycles		EQU $FF		; Count n Cycles of Vblank = n frames (with 50 = 1 second)
	Wait			EQU $FE		; One Pass Amout of Wait (in Frames)
	
; ::	TEMPORY														:
	tmp			EQU $F1
	stl			EQU $F2
	

:_CONSTANTES 														:


; ::	JOYPAD														:

	Shift_A		EQU #%10000000
	Shift_B		EQU #%01000000
	Shift_Select	EQU #%00100000
	Shift_Start	EQU #%00010000
	Shift_Up	EQU #%00001000
	Shift_Down	EQU #%00000100
	Shift_Left	EQU #%00000010
	Shift_Right	EQU #%00000001
	
	; Cross Directionals Buttons Right and Left 
	Shift_Ways	EQU #%00000011
	
; ::	PPU														:
	PPU_CTRL	EQU $2000
	PPU_MASK	EQU $2001
	PPU_STATUS	EQU $2002
	PPU_SCROLL	EQU $2005
	PPU_ADDR	EQU $2006
	PPU_DATA	EQU $2007

; ::	REGISTERS													:
	
	DisableNMI		EQU #%01111111	; Use AND With Bits_PPU_CTRL 	to set at 0
	EnableNMI		EQU #%10000000	; Use ORA With Bits_PPU_CTRL 	to set at 1
	
	IncrementPerColumn	EQU #%11111011	; Use AND with Bits_PPU_CTRL	to set at 0
	IncrementPerLine	EQU #%00000100	; Use ORA with Bits_PPU_CTRL	to set at 1 	Must be use with addressing to jump to Next Column : $PPU_ADR+ 1
	
	Data_PPU_CTRL		EQU #%10001100	
	;                             76543210		PPU_CTRL = Register $2000			
	;                             ││││││├┘								
	;                             ││││││└─────0.1─►	Name Table Select Address			
	;                             ││││││  		00=$2000  10=$2800				
	;                             ││││││  		01=$2400  11=$2C00				
	;                             ││││││  								
	;                             │││││└────────2─►	PPU Address Read/Write Increment		
	;                             │││││		1=Increment by 1				
	;                             │││││		0=Increment by 32				
	;                             │││││								
	;                             ││││└─────────3─►	Sprite Pattern Table Address			
	;                             ││││		0=$0000 1=$1000					
	;                             ││││								
	;                             │││└──────────4─►	Screen Pattern Table Address			
	;                             │││		0=$0000 1=$1000					
	;                             │││								
	;                             ││└───────────5─►	Sprite Size (pixels)				
	;                             ││		0=8x8 1=8x16					
	;                             ││								
	;                             │└────────────6─►	Execute NMI on Sprite Hit			
	;                             │			0=Disable  1=Enable				
	;                             │									
	;                             └─────────────7─►	Execute NMI on VBlank				
	;                             			0=Disable 1=Enable				
	;                             									
	
	ScreenDisplayOFF 	EQU #%11110111	; Use AND with Bits_PPU_MASK 	to set at 0
	ScreenDisplayON 	EQU #%00001000	; Use ORA with Bits_PPU_MASK 	to set at 1
	
	Data_PPU_MASK 		EQU #%00001110
	;  	       	              76543210			PPU_MASK = Register $2001		
	;                             └┼┘│││││								
	;                              │ ││││└──────0─►	Color Display					
	;                              │ ││││ 		0=All colors					
	;                              │ ││││ 		1=Mono Color					
	;                              │ ││││ 								
	;                              │ │││└───────1─►	Image Clip (Nametable?)				
	;                              │ │││		0=Don't show the left 8 pixels of screen	
	;                              │ │││		1=Show the left 8 pixels			
	;                              │ │││								
	;                              │ ││└────────2─►	Sprite Clip					
	;                              │ ││		0=Don't Show sprites in the left 8-pixel column 
	;                              │ ││		1=Show Everywhere 				
	;                              │ ││								
	;                              │ │└─────────3─►	Screen Display					
	;                              │ │		0=OFF 1=ON					
	;                              │ │								
	;                              │ └──────────4─►	Sprite Display 					
	;                              │    		0=Hide 1=Show					
	;                              │    								
	;                              └────────7.6.5─►	Full Background Color				
	;                             			000 = NONE	010 = Green			
	;                             			001 = Red	100 = Blue			
	;                             									